% Calculation of the Transmon Green QPD sled
%
% The 1 mm target beam size is because of the large gaps in the QPD sensor.
%
%
tGreen = beamPath;
tGreen.seedWaist(3.1e-3 /sqrt(2), -1e-6 , 532e-9);
targetRayleigh = 0.35;
lambda = 532e-9;
tGreen.targetWaist(sqrt(targetRayleigh*lambda/pi), 0.5, lambda);

f1 = 343e-3;   % CVI optic
f2 = -57e-3;   % CVI optic
f1 = 333e-3;    % r = 150mm fused silica
f2 = -55.6e-3;  % r = -25mm fused silica
f3 = -55.6e-3; 

tGreen.addComponent(component.lens(f1, 0, 'L1'));
tGreen.addComponent(component.lens(f2, 0.291, 'L2'));

% optimize waist
tGreen = tGreen.optimizePath('L2', [0.1 0.5], ...
    'target', [0.1 2]);
targz = tGreen.targetz;
dz = targz-tGreen.component('L2').z;

tGreen.addComponent(component.lens(f3, targz+dz, 'L3'));
tGreen.addComponent(component.flatMirror(0.18, 'QPD1')); % z by hand
tGreen.addComponent(component.flatMirror(1.06, 'QPD2')); % z by hand

%qOut = tGreen.qPropagate(tGreen.component('L2').z+1e-6);
%waistZ = -qOut.waistZ;
%rayl = qOut.rayleighRange;
%tGreen.addComponent(component.lens(-0.57, waistZ - rayl, 'L3'));

                         
                         
                         
z = -1:0.01:1.5;
figure(1)
tGreen.plotSummary(z);
shg;
display(tGreen.components);
saveas(gcf, 'GREEN_beampath.pdf', 'pdf');
return



%%%
q_in = pi*3.1e-3^2/1.064e-6 * 1i; 
lens = @(f) [1 0; -1/f 1];
mLength = @(tL) [1 tL; 0 1];

telescope = @(L1,L2,x) lens(L2)*mLength(x)*lens(L1);
newQ = @(q, ABCD) (ABCD(1,1)*q + ABCD(1,2))/(ABCD(2,1)*q + ABCD(2,2));

x = 0:0.001:0.5;
for ii = 1:length(x)
    qq(ii) =  newQ(q_in, telescope(0.343, -0.114, x(ii)));
end

    
figure(2)
plot(x, imag(qq)./real(qq))
axis([-inf inf -2 2])